# List of languages supported by Wiki projects
# https://gitlab.wikimedia.org/repos/research/mwconstants/-/blob/main/mwconstants/languages.py
WIKI_LANGUAGES = [
    "ab",
    "ace",
    "ady",
    "af",
    "ak",
    "als",
    "alt",
    "am",
    "ami",
    "an",
    "ang",
    "ar",
    "arc",
    "ary",
    "arz",
    "as",
    "ast",
    "atj",
    "av",
    "avk",
    "awa",
    "ay",
    "az",
    "azb",
    "ba",
    "ban",
    "bar",
    "bat-smg",
    "bcl",
    "be",
    "be-tarask",
    "bg",
    "bh",
    "bi",
    "bjn",
    "blk",
    "bm",
    "bn",
    "bo",
    "bpy",
    "br",
    "bs",
    "bug",
    "bxr",
    "ca",
    "cbk-zam",
    "cdo",
    "ce",
    "ceb",
    "ch",
    "chr",
    "chy",
    "ckb",
    "co",
    "cr",
    "crh",
    "cs",
    "csb",
    "cu",
    "cv",
    "cy",
    "da",
    "dag",
    "de",
    "din",
    "diq",
    "dsb",
    "dty",
    "dv",
    "dz",
    "ee",
    "el",
    "eml",
    "en",
    "eo",
    "es",
    "et",
    "eu",
    "ext",
    "fa",
    "ff",
    "fi",
    "fiu-vro",
    "fj",
    "fo",
    "fr",
    "frp",
    "frr",
    "fur",
    "fy",
    "ga",
    "gag",
    "gan",
    "gcr",
    "gd",
    "gl",
    "glk",
    "gn",
    "gom",
    "gor",
    "got",
    "gu",
    "guw",
    "gv",
    "ha",
    "hak",
    "haw",
    "he",
    "hi",
    "hif",
    "hr",
    "hsb",
    "ht",
    "hu",
    "hy",
    "hyw",
    "ia",
    "id",
    "ie",
    "ig",
    "ik",
    "ilo",
    "inh",
    "io",
    "is",
    "it",
    "iu",
    "ja",
    "jam",
    "jbo",
    "jv",
    "ka",
    "kaa",
    "kab",
    "kbd",
    "kbp",
    "kcg",
    "kg",
    "ki",
    "kk",
    "kl",
    "km",
    "kn",
    "ko",
    "koi",
    "krc",
    "ks",
    "ksh",
    "ku",
    "kv",
    "kw",
    "ky",
    "la",
    "lad",
    "lb",
    "lbe",
    "lez",
    "lfn",
    "lg",
    "li",
    "lij",
    "lld",
    "lmo",
    "ln",
    "lo",
    "lt",
    "ltg",
    "lv",
    "mad",
    "mai",
    "map-bms",
    "mdf",
    "mg",
    "mhr",
    "mi",
    "min",
    "mk",
    "ml",
    "mn",
    "mni",
    "mnw",
    "mr",
    "mrj",
    "ms",
    "mt",
    "mwl",
    "my",
    "myv",
    "mzn",
    "na",
    "nah",
    "nap",
    "nds",
    "nds-nl",
    "ne",
    "new",
    "nia",
    "nl",
    "nn",
    "no",
    "nov",
    "nqo",
    "nrm",
    "nso",
    "nv",
    "ny",
    "oc",
    "olo",
    "om",
    "or",
    "os",
    "pa",
    "pag",
    "pam",
    "pap",
    "pcd",
    "pcm",
    "pdc",
    "pfl",
    "pi",
    "pih",
    "pl",
    "pms",
    "pnb",
    "pnt",
    "ps",
    "pt",
    "pwn",
    "qu",
    "rm",
    "rmy",
    "rn",
    "ro",
    "roa-rup",
    "roa-tara",
    "ru",
    "rue",
    "rw",
    "sa",
    "sah",
    "sat",
    "sc",
    "scn",
    "sco",
    "sd",
    "se",
    "sg",
    "sh",
    "shi",
    "shn",
    "si",
    "simple",
    "sk",
    "skr",
    "sl",
    "sm",
    "smn",
    "sn",
    "so",
    "sq",
    "sr",
    "srn",
    "ss",
    "st",
    "stq",
    "su",
    "sv",
    "sw",
    "szl",
    "szy",
    "ta",
    "tay",
    "tcy",
    "te",
    "tet",
    "tg",
    "th",
    "ti",
    "tk",
    "tl",
    "tn",
    "to",
    "tpi",
    "tr",
    "trv",
    "ts",
    "tt",
    "tum",
    "tw",
    "ty",
    "tyv",
    "udm",
    "ug",
    "uk",
    "ur",
    "uz",
    "ve",
    "vec",
    "vep",
    "vi",
    "vls",
    "vo",
    "wa",
    "war",
    "wo",
    "wuu",
    "xal",
    "xh",
    "xmf",
    "yi",
    "yo",
    "za",
    "zea",
    "zh",
    "zh-classical",
    "zh-min-nan",
    "zh-yue",
    "zu",
]  # 318 languages

# unicode code points with the \p{Sentence_Break=STerm} or \p{Sentence_Break=ATerm} properties that also
# have the \p{Terminal_Punctuation} property generated with Unicode::Tussle perl script and additional
# fullstops in unicode character sets : https://www.fileformat.info/info/unicode/char/search.htm?q=.&
# preview=entity
GLOBAL_SENTENCE_TERMINATORS = [
    "...",
    "!",
    ".",
    "?",
    "։",
    "؞",
    "؟",
    "۔",
    "܀",
    "܁",
    "܂",
    "߹",
    "࠷",
    "࠹",
    "࠽",
    "࠾",
    "।",
    "॥",
    "၊",
    "။",
    "።",
    "፧",
    "፨",
    "᙮",
    "᜵",
    "᜶",
    "᠃",
    "᠉",
    "᥄",
    "᥅",
    "᪨",
    "᪩",
    "᪪",
    "᪫",
    "᭚",
    "᭛",
    "᭞",
    "᭟",
    "᰻",
    "᰼",
    "᱾",
    "᱿",
    "‼",
    "‽",
    "⁇",
    "⁈",
    "⁉",
    "⸮",
    "⸼",
    "꓿",
    "꘎",
    "꘏",
    "꛳",
    "꛷",
    "꡶",
    "꡷",
    "꣎",
    "꣏",
    "꤯",
    "꧈",
    "꧉",
    "꩝",
    "꩞",
    "꩟",
    "꫰",
    "꫱",
    "꯫",
    "﹒",
    "﹖",
    "﹗",
    "！",
    "．",
    "？",
    "ཕ",
    "བ",
    "བྷ",
    "མ",
    "ཙ",
    "၇",
    "၈",
    "Ⴞ",
    "Ⴟ",
    "Ⴠ",
    "Ⴡ",
    "ᅁ",
    "ᅂ",
    "ᅃ",
    "ᇅ",
    "ᇆ",
    "ᇍ",
    "ᇞ",
    "ᇟ",
    "ሸ",
    "ሹ",
    "ሻ",
    "ሼ",
    "ኩ",
    "ᑋ",
    "ᑌ",
    "ᗂ",
    "ᗃ",
    "ᗉ",
    "ᗊ",
    "ᗋ",
    "ᗌ",
    "ᗍ",
    "ᗎ",
    "ᗏ",
    "ᗐ",
    "ᗑ",
    "ᗒ",
    "ᗓ",
    "ᗔ",
    "ᗕ",
    "ᗖ",
    "ᗗ",
    "ᙁ",
    "ᙂ",
    "᥄",
    "᥆",
    "ᩂ",
    "ᩃ",
    "᱁",
    "᱂",
    "ỷ",
    "Ỹ",
    "橮",
    "橯",
    "櫵",
    "欷",
    "欸",
    "歄",
    "溘",
    "벟",
    "⳹",
    "⳾",
    "。",
    "︒",
    "｡",
    "𖫵",
    "𖺘",
    "𛲟",
    "𝪈",
    "།",  # dz, bo
    "⁙",  # cu
    # https://en.wikipedia.org/wiki/Khmer_script%23Spacing_and_punctuation
    "។",  # km
    "៕",  # km
    "៚",  # km
    "៙",  # km
    # https://en.wikipedia.org/wiki/Full_stop
    "෴",
    "༎",
    # https://en.wikipedia.org/wiki/Question_mark
    "¿",
    "՞",
    ";",  # looks like ; but it's different
    "𞥟",
    "吗",  # verbal question mark
    "か",  # verbal question mark
    "⳺",
    "⳻",
    "⸘",
    # https://en.wikipedia.org/wiki/Exclamation_mark
    "¡",
]  # 160 unique symbols

# List of sentence terminator symbols that are not followed by a space character
SENTENCE_TERMINATORS_WITH_NO_SPACE = set(
    [
        "༎",  # less frequent (bowiki)
        "。",
    ]
)

ABBREVIATION_ENDING_SYMBOLS = ["."]

# python regex special characters list
# https://docs.python.org/3/library/re.html#regular-expression-syntax
REGEX_META_CHARS = [
    ".",
    "+",
    "*",
    "?",
    "^",
    "$",
    "(",
    ")",
    "[",
    "]",
    "{",
    "}",
    "|",
    "\\",
]
# See: https://www.mediawiki.org/wiki/User:TJones_(WMF)/Notes/Spaceless_Writing_Systems_and_Wiki-Projects
NON_WHITESPACE_LANGUAGES_SPC_MAPPING = {
    "bo": "spc_bpe_tib.model",  # "nws_bpe_bo.model",
    "dz": "spc_bpe_tib.model",  # "nws_bpe_dz.model",
    "gan": "nws_bpe_gan.model",
    "ja": "nws_bpe_ja.model",
    "km": "nws_bpe_km.model",
    "lo": "nws_bpe_lo.model",
    "my": "nws_bpe_my.model",
    "th": "nws_bpe_th.model",
    "wuu": "nws_bpe_wuu.model",
    "zh": "nws_bpe_zh.model",
    "zh_min_nan": "nws_bpe_zh_min_nan.model",
    "zh_classical": "nws_bpe_zh_classical.model",
    "zh_yue": "nws_bpe_zh_yue.model",
}

# All unicode characters of Category:Unicode punctuation (P)
# See: https://en.wikipedia.org/wiki/Template:General_Category_(Unicode)
ALL_UNICODE_PUNCTUATION = set(
    [
        "!",
        '"',
        "#",
        "%",
        "&",
        "'",
        "(",
        ")",
        "*",
        ",",
        "-",
        ".",
        "/",
        ":",
        ";",
        "?",
        "@",
        "[",
        "\\",
        "]",
        "_",
        "{",
        "}",
        "¡",
        "§",
        "«",
        "¶",
        "·",
        "»",
        "¿",
        ";",
        "·",
        "՚",
        "՛",
        "՜",
        "՝",
        "՞",
        "՟",
        "։",
        "֊",
        "־",
        "׀",
        "׃",
        "׆",
        "׳",
        "״",
        "؉",
        "؊",
        "،",
        "؍",
        "؛",
        "؞",
        "؟",
        "٪",
        "٫",
        "٬",
        "٭",
        "۔",
        "܀",
        "܁",
        "܂",
        "܃",
        "܄",
        "܅",
        "܆",
        "܇",
        "܈",
        "܉",
        "܊",
        "܋",
        "܌",
        "܍",
        "߷",
        "߸",
        "߹",
        "࠰",
        "࠱",
        "࠲",
        "࠳",
        "࠴",
        "࠵",
        "࠶",
        "࠷",
        "࠸",
        "࠹",
        "࠺",
        "࠻",
        "࠼",
        "࠽",
        "࠾",
        "࡞",
        "।",
        "॥",
        "॰",
        "৽",
        "੶",
        "૰",
        "౷",
        "಄",
        "෴",
        "๏",
        "๚",
        "๛",
        "༄",
        "༅",
        "༆",
        "༇",
        "༈",
        "༉",
        "༊",
        "་",
        "༌",
        "།",
        "༎",
        "༏",
        "༐",
        "༑",
        "༒",
        "༔",
        "༺",
        "༻",
        "༼",
        "༽",
        "྅",
        "࿐",
        "࿑",
        "࿒",
        "࿓",
        "࿔",
        "࿙",
        "࿚",
        "၊",
        "။",
        "၌",
        "၍",
        "၎",
        "၏",
        "჻",
        "፠",
        "፡",
        "።",
        "፣",
        "፤",
        "፥",
        "፦",
        "፧",
        "፨",
        "᐀",
        "᙮",
        "᚛",
        "᚜",
        "᛫",
        "᛬",
        "᛭",
        "᜵",
        "᜶",
        "។",
        "៕",
        "៖",
        "៘",
        "៙",
        "៚",
        "᠀",
        "᠁",
        "᠂",
        "᠃",
        "᠄",
        "᠅",
        "᠆",
        "᠇",
        "᠈",
        "᠉",
        "᠊",
        "᥄",
        "᥅",
        "᨞",
        "᨟",
        "᪠",
        "᪡",
        "᪢",
        "᪣",
        "᪤",
        "᪥",
        "᪦",
        "᪨",
        "᪩",
        "᪪",
        "᪫",
        "᪬",
        "᪭",
        "᭚",
        "᭛",
        "᭜",
        "᭝",
        "᭞",
        "᭟",
        "᭠",
        "᯼",
        "᯽",
        "᯾",
        "᯿",
        "᰻",
        "᰼",
        "᰽",
        "᰾",
        "᰿",
        "᱾",
        "᱿",
        "᳀",
        "᳁",
        "᳂",
        "᳃",
        "᳄",
        "᳅",
        "᳆",
        "᳇",
        "᳓",
        "‐",
        "‑",
        "‒",
        "–",
        "—",
        "―",
        "‖",
        "‗",
        "‘",
        "’",
        "‚",
        "‛",
        "“",
        "”",
        "„",
        "‟",
        "†",
        "‡",
        "•",
        "‣",
        "․",
        "‥",
        "…",
        "‧",
        "‰",
        "‱",
        "′",
        "″",
        "‴",
        "‵",
        "‶",
        "‷",
        "‸",
        "‹",
        "›",
        "※",
        "‼",
        "‽",
        "‾",
        "‿",
        "⁀",
        "⁁",
        "⁂",
        "⁃",
        "⁅",
        "⁆",
        "⁇",
        "⁈",
        "⁉",
        "⁊",
        "⁋",
        "⁌",
        "⁍",
        "⁎",
        "⁏",
        "⁐",
        "⁑",
        "⁓",
        "⁔",
        "⁕",
        "⁖",
        "⁗",
        "⁘",
        "⁙",
        "⁚",
        "⁛",
        "⁜",
        "⁝",
        "⁞",
        "⁽",
        "⁾",
        "₍",
        "₎",
        "⌈",
        "⌉",
        "⌊",
        "⌋",
        "〈",
        "〉",
        "❨",
        "❩",
        "❪",
        "❫",
        "❬",
        "❭",
        "❮",
        "❯",
        "❰",
        "❱",
        "❲",
        "❳",
        "❴",
        "❵",
        "⟅",
        "⟆",
        "⟦",
        "⟧",
        "⟨",
        "⟩",
        "⟪",
        "⟫",
        "⟬",
        "⟭",
        "⟮",
        "⟯",
        "⦃",
        "⦄",
        "⦅",
        "⦆",
        "⦇",
        "⦈",
        "⦉",
        "⦊",
        "⦋",
        "⦌",
        "⦍",
        "⦎",
        "⦏",
        "⦐",
        "⦑",
        "⦒",
        "⦓",
        "⦔",
        "⦕",
        "⦖",
        "⦗",
        "⦘",
        "⧘",
        "⧙",
        "⧚",
        "⧛",
        "⧼",
        "⧽",
        "⳹",
        "⳺",
        "⳻",
        "⳼",
        "⳾",
        "⳿",
        "⵰",
        "⸀",
        "⸁",
        "⸂",
        "⸃",
        "⸄",
        "⸅",
        "⸆",
        "⸇",
        "⸈",
        "⸉",
        "⸊",
        "⸋",
        "⸌",
        "⸍",
        "⸎",
        "⸏",
        "⸐",
        "⸑",
        "⸒",
        "⸓",
        "⸔",
        "⸕",
        "⸖",
        "⸗",
        "⸘",
        "⸙",
        "⸚",
        "⸛",
        "⸜",
        "⸝",
        "⸞",
        "⸟",
        "⸠",
        "⸡",
        "⸢",
        "⸣",
        "⸤",
        "⸥",
        "⸦",
        "⸧",
        "⸨",
        "⸩",
        "⸪",
        "⸫",
        "⸬",
        "⸭",
        "⸮",
        "⸰",
        "⸱",
        "⸲",
        "⸳",
        "⸴",
        "⸵",
        "⸶",
        "⸷",
        "⸸",
        "⸹",
        "⸺",
        "⸻",
        "⸼",
        "⸽",
        "⸾",
        "⸿",
        "⹀",
        "⹁",
        "⹂",
        "⹃",
        "⹄",
        "⹅",
        "⹆",
        "⹇",
        "⹈",
        "⹉",
        "⹊",
        "⹋",
        "⹌",
        "⹍",
        "⹎",
        "⹏",
        "、",
        "。",
        "〃",
        "〈",
        "〉",
        "《",
        "》",
        "「",
        "」",
        "『",
        "』",
        "【",
        "】",
        "〔",
        "〕",
        "〖",
        "〗",
        "〘",
        "〙",
        "〚",
        "〛",
        "〜",
        "〝",
        "〞",
        "〟",
        "〰",
        "〽",
        "゠",
        "・",
        "꓾",
        "꓿",
        "꘍",
        "꘎",
        "꘏",
        "꙳",
        "꙾",
        "꛲",
        "꛳",
        "꛴",
        "꛵",
        "꛶",
        "꛷",
        "꡴",
        "꡵",
        "꡶",
        "꡷",
        "꣎",
        "꣏",
        "꣸",
        "꣹",
        "꣺",
        "꣼",
        "꤮",
        "꤯",
        "꥟",
        "꧁",
        "꧂",
        "꧃",
        "꧄",
        "꧅",
        "꧆",
        "꧇",
        "꧈",
        "꧉",
        "꧊",
        "꧋",
        "꧌",
        "꧍",
        "꧞",
        "꧟",
        "꩜",
        "꩝",
        "꩞",
        "꩟",
        "꫞",
        "꫟",
        "꫰",
        "꫱",
        "꯫",
        "﴾",
        "﴿",
        "︐",
        "︑",
        "︒",
        "︓",
        "︔",
        "︕",
        "︖",
        "︗",
        "︘",
        "︙",
        "︰",
        "︱",
        "︲",
        "︳",
        "︴",
        "︵",
        "︶",
        "︷",
        "︸",
        "︹",
        "︺",
        "︻",
        "︼",
        "︽",
        "︾",
        "︿",
        "﹀",
        "﹁",
        "﹂",
        "﹃",
        "﹄",
        "﹅",
        "﹆",
        "﹇",
        "﹈",
        "﹉",
        "﹊",
        "﹋",
        "﹌",
        "﹍",
        "﹎",
        "﹏",
        "﹐",
        "﹑",
        "﹒",
        "﹔",
        "﹕",
        "﹖",
        "﹗",
        "﹘",
        "﹙",
        "﹚",
        "﹛",
        "﹜",
        "﹝",
        "﹞",
        "﹟",
        "﹠",
        "﹡",
        "﹣",
        "﹨",
        "﹪",
        "﹫",
        "！",
        "＂",
        "＃",
        "％",
        "＆",
        "＇",
        "（",
        "）",
        "＊",
        "，",
        "－",
        "．",
        "／",
        "：",
        "；",
        "？",
        "＠",
        "［",
        "＼",
        "］",
        "＿",
        "｛",
        "｝",
        "｟",
        "｠",
        "｡",
        "｢",
        "｣",
        "､",
        "･",
        "𐄀",
        "𐄁",
        "𐄂",
        "𐎟",
        "𐏐",
        "𐕯",
        "𐡗",
        "𐤟",
        "𐤿",
        "𐩐",
        "𐩑",
        "𐩒",
        "𐩓",
        "𐩔",
        "𐩕",
        "𐩖",
        "𐩗",
        "𐩘",
        "𐩿",
        "𐫰",
        "𐫱",
        "𐫲",
        "𐫳",
        "𐫴",
        "𐫵",
        "𐫶",
        "𐬹",
        "𐬺",
        "𐬻",
        "𐬼",
        "𐬽",
        "𐬾",
        "𐬿",
        "𐮙",
        "𐮚",
        "𐮛",
        "𐮜",
        "𐽕",
        "𐽖",
        "𐽗",
        "𐽘",
        "𐽙",
        "𑁇",
        "𑁈",
        "𑁉",
        "𑁊",
        "𑁋",
        "𑁌",
        "𑁍",
        "𑂻",
        "𑂼",
        "𑂾",
        "𑂿",
        "𑃀",
        "𑃁",
        "𑅀",
        "𑅁",
        "𑅂",
        "𑅃",
        "𑅴",
        "𑅵",
        "𑇅",
        "𑇆",
        "𑇇",
        "𑇈",
        "𑇍",
        "𑇛",
        "𑇝",
        "𑇞",
        "𑇟",
        "𑈸",
        "𑈹",
        "𑈺",
        "𑈻",
        "𑈼",
        "𑈽",
        "𑊩",
        "𑑋",
        "𑑌",
        "𑑍",
        "𑑎",
        "𑑏",
        "𑑛",
        "𑑝",
        "𑓆",
        "𑗁",
        "𑗂",
        "𑗃",
        "𑗄",
        "𑗅",
        "𑗆",
        "𑗇",
        "𑗈",
        "𑗉",
        "𑗊",
        "𑗋",
        "𑗌",
        "𑗍",
        "𑗎",
        "𑗏",
        "𑗐",
        "𑗑",
        "𑗒",
        "𑗓",
        "𑗔",
        "𑗕",
        "𑗖",
        "𑗗",
        "𑙁",
        "𑙂",
        "𑙃",
        "𑙠",
        "𑙡",
        "𑙢",
        "𑙣",
        "𑙤",
        "𑙥",
        "𑙦",
        "𑙧",
        "𑙨",
        "𑙩",
        "𑙪",
        "𑙫",
        "𑙬",
        "𑜼",
        "𑜽",
        "𑜾",
        "𑠻",
        "𑧢",
        "𑨿",
        "𑩀",
        "𑩁",
        "𑩂",
        "𑩃",
        "𑩄",
        "𑩅",
        "𑩆",
        "𑪚",
        "𑪛",
        "𑪜",
        "𑪞",
        "𑪟",
        "𑪠",
        "𑪡",
        "𑪢",
        "𑱁",
        "𑱂",
        "𑱃",
        "𑱄",
        "𑱅",
        "𑱰",
        "𑱱",
        "𑻷",
        "𑻸",
        "𑿿",
        "𒑰",
        "𒑱",
        "𒑲",
        "𒑳",
        "𒑴",
        "𖩮",
        "𖩯",
        "𖫵",
        "𖬷",
        "𖬸",
        "𖬹",
        "𖬺",
        "𖬻",
        "𖭄",
        "𖺗",
        "𖺘",
        "𖺙",
        "𖺚",
        "𖿢",
        "𛲟",
        "𝪇",
        "𝪈",
        "𝪉",
        "𝪊",
        "𝪋",
        "𞥞",
        "𞥟",
    ]
)
